﻿
-- My Garrison is Done --
-- Written by Jaxom of Hellfire --
-- Based on an Idea by Cederra of Hellfire, He helps test my addons and this was his idea. --
-- GNU General Public License version 3 (GPLv3) --

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

-- DEFAULTS --

local playerName = UnitName("player");		
local guildName = GetGuildInfo("player");    
local self = GarrisonDone;  

-- ON LOAD --

function GarrisonDone_OnLoad()

    
-- START --
        
        GarrisonDoneEditBox:Show();  -- Show page
 
        
-- LOCK FRAME SIZE SETTINGS --
        
        GarrisonDoneFrame:SetMinResize(195,245);
        GarrisonDoneFrame:SetMaxResize(195,245);
        
-- REGISTER EVENTS --
        
        GarrisonDone:RegisterEvent("VARIABLES_LOADED");
        GarrisonDone:RegisterEvent("STORETEXT");
        GarrisonDone:RegisterEvent("ONTEXTCHANGED");
        GarrisonDone:RegisterEvent("UPDATE");
        GarrisonDone:RegisterEvent("GETTEXT");
        GarrisonDone:RegisterEvent("SETTEXT");
        GarrisonDone:RegisterEvent("ONFOCUS");
        GarrisonDone:RegisterEvent("SETFOCUS");
        GarrisonDone:RegisterEvent("CLEARFOCUS");
        GarrisonDone:RegisterEvent("ONSHOW");
        GarrisonDone:RegisterEvent("ONHIDE");
        GarrisonDone:RegisterEvent("ONCLICK");
        GarrisonDone:RegisterEvent("REGISTERFORDRAG");
        GarrisonDone:RegisterEvent("PLAYER_ENTERING_WORLD");
        
	    table.insert(UISpecialFrames,"GarrisonDoneFrame");    
               
-- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
        SLASH_GARRISONDONE2 = "/gdone";
end
        
    -- Set Default Variables --

function GarrisonDone_Loaded()
    if GarrisonDone_Varsc == nil then
        GarrisonDone_Varsc = SimpleNotepad_Defaults
        DEFAULT_CHAT_FRAME:AddMessage("My Garrison is Done found no database. Generating Defaults...");
        end
    if (GarrisonDone_Varsc["version"] < GarrisonDone_Version) then
        GarrisonDone_Varsc_temp = GarrisonDone_Defaults;
        for k,v in GarrisonDone_Varsc do
    if (GarrisonDone_Defaults["Vars"][k]) then
        GarrisonDone_Varsc_temp[k] = v;
     end
  end
        GarrisonDone_Varsc_temp["version"] = GarrisonDone_Version;
        GarrisonDone_Varsc = GarrisonDone_Varsc_temp;
    end
end

    -- Function - Load Variables and fire it up :) --

-- EVENT FUNCTIONS --

function GarrisonDone_OnEvent(event, self, ...)
        if event == "VARIABLES_LOADED" then
            
		GarrisonDone_Varsc.q = tostring(GarrisonDone_Varsc.q);
		if GarrisonDone_Varsc.q == "nil" then
			GarrisonDone_Varsc.q = "";
		end
		
		GarrisonDone_Varsc.w = tostring(GarrisonDone_Varsc.w);
		if GarrisonDone_Varsc == "nil" then
			GarrisonDone_Varsc.w = "";
		end
       
    -- Set Table to look for Herbs and Ore --  
		
        if(not table.contains) then
	    function table.contains(table, element)
  		for _, value in pairs(table) do
	    	if value == element then
	      		return true
	    	end
	  	end

	  	return false
	end
end
       
       
       
        GarrisonDone_Loaded();
        GarrisonDone_SetText();
    end
 end
        
 


-- FRAME STARTS HERE --

    -- SHOW FRAME --    
function GarrisonDone_OnShow(self)
    GarrisonDoneFrame:Show();
    GarrisonDone_Update();
    GarrisonDone_SetText();
end

    -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDoneFrame:IsVisible() then
		GarrisonDoneFrame:Hide();
	else
		GarrisonDoneFrame:Show();
	end
end

    -- MOVES FRAME --
function GarrisonDone_OnMouseDown(self)
    if Button == "RightButton" then
	    GarrisonDoneFrame:StartMoving();
    end
end

function GarrisonDone_OnMouseUp(self)
	if Button == "RightButton" then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end


-- REMOVES FRAME IF DISABLE TRUE --
function GarrisonDone_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end


-- Function - Is the Player in there Garrison, if there not we dont want to show --        

-- Get Garrison Map Id's, so we know were the Garrison is --

local garrisonMapIds = { 1152, 1330, 1153, 1154, 1158, 1331, 1159, 1160 }

function IsInGarrison()
	local _, _, _, _, _, _, _, mapId = GetInstanceInfo()

	return table.contains(garrisonMapIds, mapId)
    end
    
    
    -- this is wrong, need it to use the map ids, we just created --
    
  --  if zone == GetCurrentMapZone("Lunarfall") then
  --      GarrisonDone_Frame:Show()
  --      elseif zone ~= GetCurrentMapZone("Lunarfall") then
  --      GarrisonDone_Frame:Hide()        
  --  elseif GarrisonDone_Frame:Show() == true then -- Ready for saved variable to be added --
--        GarrisonDone_Frame:Show();
--    else
--        GarrisonDone_Frame:Hide();
-- end



    -- ON TEXT CHANGE we will probably need to do something here --
function GarrisonDone_OnTextChanged(self)
	
end



-- TEXT FUNCTIONS --


function GarrisonDone_Update()
	-- set current contents --
	if (GarrisonDoneEditBox:IsShown()) then
		GarrisonDonePageName:SetText("My Garrison is Done. |cff007fffV" ..GarrisonDone_Version.."");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDFAPageName:SetText("|cff007fffFollowers Available|r = |cffff0000Test");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDFMPageName:SetText("|cff007fffFollowers Missions|r = |cffff0000Test");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDFWPageName:SetText("|cff007fffFollowers Working|r = |cffff0000Test");
        end
    
    if (GarrisonDoneEditBox:IsShown()) then
		MGDMAPageName:SetText("|cff007fffMissions Available|r = |cffff0000Test");
        end
    
    if (GarrisonDoneEditBox:IsShown()) then
		MGDMCPageName:SetText("|cff007fffMissions Complete|r = |cffff0000Test");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDMNPageName:SetText("|cff007fffMining Nodes|r   =   |cffff0000X/16");
        end
        
    if (GarrisonDoneEditBox:IsShown()) then
		MGDHNPageName:SetText("|cff007fffHerb Nodes|r   =   |cffff0000X/16");
        end
        
        GarrisonDoneEditBox:SetWidth(GarrisonDoneFrame:GetWidth()-50) -- might be to much --
        
        -- add other stuff we need to update later here --
end

function GarrisonDone_SetText()
	-- SET TEXT we want it to set the correct text in the right place and this might not be the most efficient way --
	GarrisonDoneEditBox:SetText("Test Text");
	
end

function GarrisonDone_StoreText(playSoundFx)
	-- SAVE TEXT we are going to want to save certain variables to display again  --
	GarrisonDone_Varsc.w = GarrisonDoneEditBox:GetText();
	
	
	
end



 
   



 -- LDB LAUNCHER --
 
    
    local GarrisonDone_Varsc = GarrisonDone_Varsc
    local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1")
    
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "launcher",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button)
            if (button == "LeftButton") then
            if GarrisonDoneFrame:IsVisible() then
		        GarrisonDoneFrame:Hide()
	        else
		        GarrisonDoneFrame:Show()
	        end
            elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("GarrisonDone") 
        end
    end,
            OnTooltipShow = function(tooltip)
                tooltip:AddLine('My Garrison is Done ('..GarrisonDone_Version..')')
                tooltip:AddLine('|cffffff00Left click for My Garrison Panel')
                tooltip:AddLine('|cffffff00Right Click for Interface Panel')
            end,
        })


 

   -- INTERFACE OPTIONS MENU -- 
    
   -- FRAME 1 --
  
   
    
	local garrisondone = CreateFrame("Frame", "GarrisonDone", UIParent)
	garrisondone:Hide()
    garrisondone:IsResizable(true)
    garrisondone:SetMinResize(350,250)
	garrisondone.name = "My Garrison"
    garrisondone:SetBackdropColor(0, 0, 0, 1)
	garrisondone:SetWidth(250)
	garrisondone:SetHeight(400)
	garrisondone:SetPoint("CENTER", UIParent, "CENTER")
	InterfaceOptions_AddCategory(garrisondone)

	local title = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -20)
	title:SetText("My Garrison is Done ("..GarrisonDone_Version..")" )
 
    
    local mgdEditBox = CreateFrame("EditBox", "GarrisonDoneEditBox", garrisondone)
    mgdEditBox:SetPoint ("TOPLEFT",26,-42)
	mgdEditBox:EnableMouse(false)
	mgdEditBox:SetAutoFocus(false)
	mgdEditBox:SetFontObject(GameFontNormal)
	mgdEditBox:SetWidth(450)
	mgdEditBox:SetHeight(120)
    mgdEditBox:SetText("")
	mgdEditBox:Show()
    
    local mgdEditBoxText = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -5)
	mgdEditBoxText:SetWidth(420)
	mgdEditBoxText:SetHeight(110)
    mgdEditBoxText:SetFontObject(GameFontHighlight)
    mgdEditBoxText:SetJustifyH("LEFT")
	mgdEditBoxText:SetText("Garrison Done")
    
    local mgdEditBoxText2 = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -115)
	mgdEditBoxText2:SetWidth(420)
	mgdEditBoxText2:SetHeight(110)
    mgdEditBoxText2:SetFontObject(GameFontHighlight)
    mgdEditBoxText2:SetJustifyH("LEFT")
	mgdEditBoxText2:SetText(" xml. |cff007fffJaxom of Hellfire EU")
      

     -- OPTIONS TITLE --
    
    local mgdtitle = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontHighlightLarge")
	mgdtitle:SetPoint("TOPLEFT", 16, -287)
	mgdtitle:SetText("|cff007fffOptions")       
                    
    -- HIDE BUTTON --
    
    local mgdmini = CreateFrame("CheckButton", "GarrisonDoneButton1", garrisondone)
	mgdmini:SetWidth(26)
	mgdmini:SetHeight(26)
	mgdmini:SetPoint("TOPLEFT", 16, -317)
--    gdmini:SetChecked(GarrisonDone_Varsc.button == false)
    mgdmini:SetScript("OnClick", function(self)
            if self:GetChecked() then
    --        GarrisonDone_Vars.button = false
    --        MGD_Button:Show()
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Button is now ON");
            else
    --        GarrisonDone_Vars.button = true
    --        MGD_Button:Hide()
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Button is now OFF");
            end
	end--function
    )
    
   
	mgdmini:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	mgdmini:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	mgdmini:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	mgdmini:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local mgdminiText = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlight")
	mgdminiText:SetPoint("LEFT", mgdmini, "RIGHT", 0, 2)
	mgdminiText:SetText("|CFF00AA00Show/Hide Garrison Button|r")
    
    local mgdminiText2 = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlightSmall")
	mgdminiText2:SetPoint("LEFT", mgdmini, "RIGHT", 5, -10)
    mgdminiText2:SetText("LDB Slidebar Icon and Titan Panel is Available")
    
   -- Add other options as we think of them --
    
    
